Package org.jboss.resteasy.client.jaxrs.internal

## Class ClientWebTarget

- java.lang.Object
- - org.jboss.resteasy.client.jaxrs.internal.ClientWebTarget

- All Implemented Interfaces:
    `javax.ws.rs.client.WebTarget`, `javax.ws.rs.core.Configurable<javax.ws.rs.client.WebTarget>`, `ResteasyWebTarget`

      public class ClientWebTarget
      extends Object
      implements ResteasyWebTarget

  Version:
    $Revision: 1 $
  Author:
    Bill Burke

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected boolean` | `chunked` |
    `protected ResteasyClient` | `client` |
    `protected ClientConfiguration` | `configuration` |
    `protected javax.ws.rs.core.UriBuilder` | `uriBuilder` |

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `` | `ClientWebTarget​(ResteasyClient client, String uri, ClientConfiguration configuration)` |
    `` | `ClientWebTarget​(ResteasyClient client, URI uri, ClientConfiguration configuration)` |
    `` | `ClientWebTarget​(ResteasyClient client, javax.ws.rs.core.UriBuilder uriBuilder, ClientConfiguration configuration)` |
    `protected` | `ClientWebTarget​(ResteasyClient client, ClientConfiguration configuration)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `ResteasyWebTarget` | `clone()` |
    `protected ClientInvocationBuilder` | `createClientInvocationBuilder​(ResteasyClient client, URI uri, ClientConfiguration configuration)` |
    `protected <T> ProxyBuilder<T>` | `createProxyBuilder​(Class<T> proxyInterface, ClientWebTarget cwt)` |
    `javax.ws.rs.core.Configuration` | `getConfiguration()` |
    `ResteasyClient` | `getResteasyClient()` |
    `URI` | `getUri()` |
    `javax.ws.rs.core.UriBuilder` | `getUriBuilder()` |
    `ResteasyWebTarget` | `matrixParam​(String name, Object... values)` |
    `protected ClientWebTarget` | `newInstance​(ResteasyClient client, javax.ws.rs.core.UriBuilder uriBuilder, ClientConfiguration configuration)` |
    `ResteasyWebTarget` | `path​(Class<?> resource)` |
    `ResteasyWebTarget` | `path​(Method method)` |
    `ResteasyWebTarget` | `path​(String path)` |
    `ResteasyWebTarget` | `property​(String name, Object value)` |
    `<T> T` | `proxy​(Class<T> proxyInterface)` |
    `<T> ProxyBuilder<T>` | `proxyBuilder​(Class<T> proxyInterface)` |
    `ResteasyWebTarget` | `queryParam​(String name, Object... values)` |
    `ResteasyWebTarget` | `queryParamNoTemplate​(String name, Object... values)` | Will encode any '{}' characters and not treat them as template parameters.
    `ResteasyWebTarget` | `queryParams​(javax.ws.rs.core.MultivaluedMap<String,​Object> parameters)` |
    `ResteasyWebTarget` | `queryParamsNoTemplate​(javax.ws.rs.core.MultivaluedMap<String,​Object> parameters)` | Will encode any '{}' characters and not treat them as template parameters.
    `ResteasyWebTarget` | `register​(Class<?> componentClass)` |
    `ResteasyWebTarget` | `register​(Class<?> componentClass, int priority)` |
    `ResteasyWebTarget` | `register​(Class<?> componentClass, Class<?>... contracts)` |
    `ResteasyWebTarget` | `register​(Class<?> componentClass, Map<Class<?>,​Integer> contracts)` |
    `ResteasyWebTarget` | `register​(Object component)` |
    `ResteasyWebTarget` | `register​(Object component, int priority)` |
    `ResteasyWebTarget` | `register​(Object component, Class<?>... contracts)` |
    `ResteasyWebTarget` | `register​(Object component, Map<Class<?>,​Integer> contracts)` |
    `javax.ws.rs.client.Invocation.Builder` | `request()` |
    `javax.ws.rs.client.Invocation.Builder` | `request​(String... acceptedResponseTypes)` |
    `javax.ws.rs.client.Invocation.Builder` | `request​(javax.ws.rs.core.MediaType... acceptedResponseTypes)` |
    `ResteasyWebTarget` | `resolveTemplate​(String name, Object value)` |
    `ResteasyWebTarget` | `resolveTemplate​(String name, Object value, boolean encodeSlashInPath)` |
    `ResteasyWebTarget` | `resolveTemplateFromEncoded​(String name, Object value)` |
    `ResteasyWebTarget` | `resolveTemplates​(Map<String,​Object> templateValues)` |
    `ResteasyWebTarget` | `resolveTemplates​(Map<String,​Object> templateValues, boolean encodeSlashInPath)` |
    `ResteasyWebTarget` | `resolveTemplatesFromEncoded​(Map<String,​Object> templateValues)` |
    `ResteasyWebTarget` | `setChunked​(boolean chunked)` |

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### client

          protected ResteasyClient client

    - #### uriBuilder

          protected javax.ws.rs.core.UriBuilder uriBuilder

    - #### configuration

          protected ClientConfiguration configuration

    - #### chunked

          protected boolean chunked

  - ### Constructor Detail

    - #### ClientWebTarget

          protected ClientWebTarget​(ResteasyClient client,
                                    ClientConfiguration configuration)

    - #### ClientWebTarget

          public ClientWebTarget​(ResteasyClient client,
                                 String uri,
                                 ClientConfiguration configuration)
                          throws IllegalArgumentException,
                                 NullPointerException

      Throws:
        `IllegalArgumentException`
        `NullPointerException`

    - #### ClientWebTarget

          public ClientWebTarget​(ResteasyClient client,
                                 URI uri,
                                 ClientConfiguration configuration)
                          throws NullPointerException

      Throws:
        `NullPointerException`

    - #### ClientWebTarget

          public ClientWebTarget​(ResteasyClient client,
                                 javax.ws.rs.core.UriBuilder uriBuilder,
                                 ClientConfiguration configuration)
                          throws NullPointerException

      Throws:
        `NullPointerException`

  - ### Method Detail

    - #### clone

          public ResteasyWebTarget clone()

      Specified by:
        `clone` in interface `ResteasyWebTarget`
      Overrides:
        `clone` in class `Object`

    - #### getResteasyClient

          public ResteasyClient getResteasyClient()

      Specified by:
        `getResteasyClient` in interface `ResteasyWebTarget`

    - #### proxy

          public <T> T proxy​(Class<T> proxyInterface)

      Specified by:
        `proxy` in interface `ResteasyWebTarget`

    - #### proxyBuilder

          public <T> ProxyBuilder<T> proxyBuilder​(Class<T> proxyInterface)

      Specified by:
        `proxyBuilder` in interface `ResteasyWebTarget`

    - #### createProxyBuilder

          protected <T> ProxyBuilder<T> createProxyBuilder​(Class<T> proxyInterface,
                                                           ClientWebTarget cwt)

    - #### getUri

          public URI getUri()

      Specified by:
        `getUri` in interface `javax.ws.rs.client.WebTarget`

    - #### getUriBuilder

          public javax.ws.rs.core.UriBuilder getUriBuilder()

      Specified by:
        `getUriBuilder` in interface `javax.ws.rs.client.WebTarget`

    - #### getConfiguration

          public javax.ws.rs.core.Configuration getConfiguration()

      Specified by:
        `getConfiguration` in interface `javax.ws.rs.core.Configurable<javax.ws.rs.client.WebTarget>`

    - #### path

          public ResteasyWebTarget path​(String path)
                                 throws NullPointerException

      Specified by:
        `path` in interface `ResteasyWebTarget`
      Specified by:
        `path` in interface `javax.ws.rs.client.WebTarget`
      Throws:
        `NullPointerException`

    - #### path

          public ResteasyWebTarget path​(Class<?> resource)
                                 throws IllegalArgumentException

      Specified by:
        `path` in interface `ResteasyWebTarget`
      Throws:
        `IllegalArgumentException`

    - #### path

          public ResteasyWebTarget path​(Method method)
                                 throws IllegalArgumentException

      Specified by:
        `path` in interface `ResteasyWebTarget`
      Throws:
        `IllegalArgumentException`

    - #### resolveTemplate

          public ResteasyWebTarget resolveTemplate​(String name,
                                                   Object value)
                                            throws NullPointerException

      Specified by:
        `resolveTemplate` in interface `ResteasyWebTarget`
      Specified by:
        `resolveTemplate` in interface `javax.ws.rs.client.WebTarget`
      Throws:
        `NullPointerException`

    - #### resolveTemplates

          public ResteasyWebTarget resolveTemplates​(Map<String,​Object> templateValues)
                                             throws NullPointerException

      Specified by:
        `resolveTemplates` in interface `ResteasyWebTarget`
      Specified by:
        `resolveTemplates` in interface `javax.ws.rs.client.WebTarget`
      Throws:
        `NullPointerException`

    - #### resolveTemplate

          public ResteasyWebTarget resolveTemplate​(String name,
                                                   Object value,
                                                   boolean encodeSlashInPath)
                                            throws NullPointerException

      Specified by:
        `resolveTemplate` in interface `ResteasyWebTarget`
      Specified by:
        `resolveTemplate` in interface `javax.ws.rs.client.WebTarget`
      Throws:
        `NullPointerException`

    - #### resolveTemplateFromEncoded

          public ResteasyWebTarget resolveTemplateFromEncoded​(String name,
                                                              Object value)
                                                       throws NullPointerException

      Specified by:
        `resolveTemplateFromEncoded` in interface `ResteasyWebTarget`
      Specified by:
        `resolveTemplateFromEncoded` in interface `javax.ws.rs.client.WebTarget`
      Throws:
        `NullPointerException`

    - #### resolveTemplatesFromEncoded

          public ResteasyWebTarget resolveTemplatesFromEncoded​(Map<String,​Object> templateValues)
                                                        throws NullPointerException

      Specified by:
        `resolveTemplatesFromEncoded` in interface `ResteasyWebTarget`
      Specified by:
        `resolveTemplatesFromEncoded` in interface `javax.ws.rs.client.WebTarget`
      Throws:
        `NullPointerException`

    - #### resolveTemplates

          public ResteasyWebTarget resolveTemplates​(Map<String,​Object> templateValues,
                                                    boolean encodeSlashInPath)
                                             throws NullPointerException

      Specified by:
        `resolveTemplates` in interface `ResteasyWebTarget`
      Specified by:
        `resolveTemplates` in interface `javax.ws.rs.client.WebTarget`
      Throws:
        `NullPointerException`

    - #### matrixParam

          public ResteasyWebTarget matrixParam​(String name,
                                               Object... values)
                                        throws NullPointerException

      Specified by:
        `matrixParam` in interface `ResteasyWebTarget`
      Specified by:
        `matrixParam` in interface `javax.ws.rs.client.WebTarget`
      Throws:
        `NullPointerException`

    - #### queryParam

          public ResteasyWebTarget queryParam​(String name,
                                              Object... values)
                                       throws NullPointerException

      Specified by:
        `queryParam` in interface `ResteasyWebTarget`
      Specified by:
        `queryParam` in interface `javax.ws.rs.client.WebTarget`
      Throws:
        `NullPointerException`

    - #### queryParams

          public ResteasyWebTarget queryParams​(javax.ws.rs.core.MultivaluedMap<String,​Object> parameters)
                                        throws IllegalArgumentException,
                                               NullPointerException

      Specified by:
        `queryParams` in interface `ResteasyWebTarget`
      Throws:
        `IllegalArgumentException`
        `NullPointerException`

    - #### queryParamNoTemplate

          public ResteasyWebTarget queryParamNoTemplate​(String name,
                                                        Object... values)
                                                 throws NullPointerException

      Description copied from interface: `ResteasyWebTarget`
      Will encode any '{}' characters and not treat them as template parameters.
      Specified by:
        `queryParamNoTemplate` in interface `ResteasyWebTarget`
      Parameters:
        `name` - name
        `values` - values
      Returns:
        web resource target
      Throws:
        `NullPointerException`

    - #### queryParamsNoTemplate

          public ResteasyWebTarget queryParamsNoTemplate​(javax.ws.rs.core.MultivaluedMap<String,​Object> parameters)
                                                  throws IllegalArgumentException,
                                                         NullPointerException

      Description copied from interface: `ResteasyWebTarget`
      Will encode any '{}' characters and not treat them as template parameters.
      Specified by:
        `queryParamsNoTemplate` in interface `ResteasyWebTarget`
      Parameters:
        `parameters` - parameters map
      Returns:
        web resource target
      Throws:
        `IllegalArgumentException`
        `NullPointerException`

    - #### newInstance

          protected ClientWebTarget newInstance​(ResteasyClient client,
                                                javax.ws.rs.core.UriBuilder uriBuilder,
                                                ClientConfiguration configuration)

    - #### request

          public javax.ws.rs.client.Invocation.Builder request()

      Specified by:
        `request` in interface `javax.ws.rs.client.WebTarget`

    - #### request

          public javax.ws.rs.client.Invocation.Builder request​(String... acceptedResponseTypes)

      Specified by:
        `request` in interface `javax.ws.rs.client.WebTarget`

    - #### request

          public javax.ws.rs.client.Invocation.Builder request​(javax.ws.rs.core.MediaType... acceptedResponseTypes)

      Specified by:
        `request` in interface `javax.ws.rs.client.WebTarget`

    - #### createClientInvocationBuilder

          protected ClientInvocationBuilder createClientInvocationBuilder​(ResteasyClient client,
                                                                          URI uri,
                                                                          ClientConfiguration configuration)

    - #### property

          public ResteasyWebTarget property​(String name,
                                            Object value)

      Specified by:
        `property` in interface `javax.ws.rs.core.Configurable<javax.ws.rs.client.WebTarget>`
      Specified by:
        `property` in interface `ResteasyWebTarget`

    - #### register

          public ResteasyWebTarget register​(Class<?> componentClass)

      Specified by:
        `register` in interface `javax.ws.rs.core.Configurable<javax.ws.rs.client.WebTarget>`
      Specified by:
        `register` in interface `ResteasyWebTarget`

    - #### register

          public ResteasyWebTarget register​(Class<?> componentClass,
                                            int priority)

      Specified by:
        `register` in interface `javax.ws.rs.core.Configurable<javax.ws.rs.client.WebTarget>`
      Specified by:
        `register` in interface `ResteasyWebTarget`

    - #### register

          public ResteasyWebTarget register​(Class<?> componentClass,
                                            Class<?>... contracts)

      Specified by:
        `register` in interface `javax.ws.rs.core.Configurable<javax.ws.rs.client.WebTarget>`
      Specified by:
        `register` in interface `ResteasyWebTarget`

    - #### register

          public ResteasyWebTarget register​(Class<?> componentClass,
                                            Map<Class<?>,​Integer> contracts)

      Specified by:
        `register` in interface `javax.ws.rs.core.Configurable<javax.ws.rs.client.WebTarget>`
      Specified by:
        `register` in interface `ResteasyWebTarget`

    - #### register

          public ResteasyWebTarget register​(Object component)

      Specified by:
        `register` in interface `javax.ws.rs.core.Configurable<javax.ws.rs.client.WebTarget>`
      Specified by:
        `register` in interface `ResteasyWebTarget`

    - #### register

          public ResteasyWebTarget register​(Object component,
                                            int priority)

      Specified by:
        `register` in interface `javax.ws.rs.core.Configurable<javax.ws.rs.client.WebTarget>`
      Specified by:
        `register` in interface `ResteasyWebTarget`

    - #### register

          public ResteasyWebTarget register​(Object component,
                                            Class<?>... contracts)

      Specified by:
        `register` in interface `javax.ws.rs.core.Configurable<javax.ws.rs.client.WebTarget>`
      Specified by:
        `register` in interface `ResteasyWebTarget`

    - #### register

          public ResteasyWebTarget register​(Object component,
                                            Map<Class<?>,​Integer> contracts)

      Specified by:
        `register` in interface `javax.ws.rs.core.Configurable<javax.ws.rs.client.WebTarget>`
      Specified by:
        `register` in interface `ResteasyWebTarget`

    - #### setChunked

          public ResteasyWebTarget setChunked​(boolean chunked)

      Specified by:
        `setChunked` in interface `ResteasyWebTarget`